/**************************************************************/
//Program title:- Implementation of Topological ordering on Graph using java
//Roll no.:-

class Topo
{
	public int G[][],i,j,k=0;
	int flag=2;
	public int n,edges;
	public int b[],indegree[],valid[];
	
	public Topo(int MAX)
	{
		G=new int[MAX][MAX];
		indegree=new int[MAX];
		b=new int[MAX];
		valid=new int[MAX];
		for(i=0;i<MAX;i++)	//initialising graph
		{
			for(j=0;j<MAX;j++)
			{
				G[i][j]=0;
			}
		}
		for(i=0;i<MAX;i++)
		{
			valid[i]=1;
			indegree[i]=-99;
		}
	} //end of constructor

	int create()
	{
		n=5;
		edges=7;
		G[0][2]=1;
		G[0][3]=1;

		G[1][0]=1;
		G[1][3]=1;
		
		G[2][4]=1;

		G[3][2]=1;
		G[3][4]=1;

		return n;	
	}

	void Display(int n)
	{
		int v1,v2;
		for(v1=0;v1<n;v1++)
		{
			System.out.print("\n\t");
			for(v2=0;v2<n;v2++)
			{
				System.out.print("  "+G[v1][v2]);
			}
		}
	}

	int Compute_Indeg(int node,int n)
	{
		int v1,indeg_count=0;
		for(v1=0;v1<n;v1++)
		{
			if(G[v1][node]==1)  //checking for incoming edges
			{
				indeg_count++;
			}
		}
		return indeg_count++;
	}
	
	void Topo_ordering(int n)
	{
		int s=0,i=0,ch=n;
		
		while(i<n)
		{
			if(valid[i]==1)
			{
				indegree[i]=Compute_Indeg(i,n);
				if(indegree[i]==0)
				{
					b[k]=i;
					k++;
					valid[i]=0;
					for(s=0;s<n;s++)
					{
						G[i][s]=-1;
					}
					for(int m=0;m<n;m++)
					{
						if(valid[m]==0)
							flag=1;
						else
							flag=0;
					}
				}
			}
			if(flag==1)
				break;
			else
				i++;
		}
		if(flag==0)
			Topo_ordering(ch);
	}

	void topoResult()
	{
		System.out.println("\n\nThe result after topological sorting is.....\n");
		for(i=0;i<n;i++)
			System.out.print("\t "+b[i]);
		System.out.println("\n");
	}
} // end of class

class Test
{
	public static void main(String[] args) 
	{
		int edges,v1,v2;
		Topo obj=new Topo(5);
		obj.n=obj.create();
		System.out.println("\nThe Adjecency matrix is :");
		obj.Display(obj.n);
		obj.Topo_ordering(obj.n);
		obj.topoResult();
	}
}

